package v21.fontgame 
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.TextEvent;
	import flash.text.TextField;
	import flash.text.Font;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.text.FontType;
	
	/**
	 * ...
	 * @author v21
	 */
	
	public class Game extends Sprite
	{
		
		private var availableFonts : Array = Font.enumerateFonts(true);
		private var potentialFonts : Array = new Array();
		private var possibleChars : String = "qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM";
		
		private var sampleField : TextField = new TextField();
		private var textFormat : TextFormat = new TextFormat();
		
		private var choice1 : TextField = new TextField();
		private var choice2 : TextField = new TextField();
		private var choice3 : TextField = new TextField();
		private var choice4 : TextField = new TextField();
		private var choice5 : TextField = new TextField();
		
		private var choices : Array = new Array();
		
		private var correctAnswer : int;
		
		private var bg : TextField = new TextField();
		
		private var next : TextField = new TextField();
		
		private var winsDisplayLabel : TextField = new TextField();
		private var lossDisplayLabel : TextField = new TextField();
		private var winsDisplay : TextField = new TextField();
		private var lossDisplay : TextField = new TextField();
			
		private var wins : int = 0;
		private var losses : int = 0;
		public function Game() 
		{
			choices.push(choice1, choice2, choice3, choice4, choice5);
			
			bg.width = 800;
			bg.height = 600;
			bg.background = true;
			bg.backgroundColor = 0xFFFF80;
			addChild(bg);
			
			var labelTextFormat : TextFormat = new TextFormat();
			//labelTextFormat.font = (selectRandom(availableFonts) as Font).fontName;
			labelTextFormat.size = 20;
			labelTextFormat.align = TextFormatAlign.CENTER;
			
			
			winsDisplayLabel.defaultTextFormat = labelTextFormat;
			winsDisplayLabel.text = "Wins";
			winsDisplayLabel.x = 150;
			winsDisplayLabel.y = 50;
			winsDisplayLabel.border = false;
			addChild(winsDisplayLabel);
			
			
			lossDisplayLabel.defaultTextFormat = labelTextFormat;
			lossDisplayLabel.text = "Losses";
			lossDisplayLabel.x = 550;
			lossDisplayLabel.y = 50;
			lossDisplayLabel.border = false;
			addChild(lossDisplayLabel);
			
			var scoreTextFormat : TextFormat = new TextFormat();
			//labelTextFormat.font = (selectRandom(availableFonts) as Font).fontName;
			scoreTextFormat.size = 30;
			scoreTextFormat.align = TextFormatAlign.CENTER;
			
			winsDisplay.defaultTextFormat = scoreTextFormat;
			winsDisplay.text = wins.toString();
			winsDisplay.x = 150;
			winsDisplay.y = 75;
			addChild(winsDisplay);
			
			lossDisplay.defaultTextFormat = scoreTextFormat;
			lossDisplay.text = losses.toString();
			lossDisplay.x = 550;
			lossDisplay.y = 75;
			addChild(lossDisplay);
			
			next.defaultTextFormat = scoreTextFormat;
			next.text = "next";
			next.x = 350;
			next.y = 530;
			next.height = 50;
			next.border = true;
			next.selectable = false;
			next.addEventListener(MouseEvent.CLICK, showNext);
			//addChild(next);
			
			for (var i:int = 0; i < availableFonts.length; i++) 
			{
				
				if ((availableFonts[i] as Font).fontName != "" && (availableFonts[i] as Font).fontType == FontType.DEVICE) {
					potentialFonts.push(availableFonts[i]);
				}
				else {
					//trace((availableFonts[i] as Font).fontName);
				}
			}
			
			newSample();
		}
		
		public function newSample () : void
		{
			textFormat.font = (selectRandom(potentialFonts) as Font).fontName;
			textFormat.size = 100;
			textFormat.align = TextFormatAlign.CENTER;
			sampleField.defaultTextFormat = textFormat;
			sampleField.text = possibleChars.charAt(Math.round(Math.random() * possibleChars.length));
			sampleField.width = 300;
			sampleField.height = 300;
			sampleField.x = 250;
			sampleField.y = 200;
			
			addChild(sampleField);
			
			correctAnswer = Math.round(Math.random() * (choices.length - 1));
			trace(correctAnswer);
			var choiceX : Number = 50;
			var choiceY : Number = 450;
			
			var choiceTextFormat : TextFormat = new TextFormat();
			//choiceTextFormat.font = "Arial";
			choiceTextFormat.size = 14;
			choiceTextFormat.align = TextFormatAlign.CENTER;
				
			trace(textFormat.font);
			for (var i:int = 0; i < choices.length; i++) 
			{
				
				(choices[i] as TextField).defaultTextFormat = choiceTextFormat;
				if (i == correctAnswer) {
					(choices[i] as TextField).text = textFormat.font;
				}
				else {
					//while ((choices[i] as TextField).text != textFormat.font)
					//{
						var randomFont : Font = (selectRandom(availableFonts) as Font);
						if (randomFont != null)	(choices[i] as TextField).text = randomFont.fontName;
					//}
				}
				choices[i].x = choiceX;
				choices[i].y = choiceY;
				(choices[i] as TextField).background = true;
				(choices[i] as TextField).backgroundColor = 0x80FFFF;
				(choices[i] as TextField).border = true;
				(choices[i] as TextField).borderColor = 0x008888;
				(choices[i] as TextField).height = 60;
				(choices[i] as TextField).wordWrap = true;
				(choices[i] as TextField).selectable = false;
				
				choiceX += 150;
				(choices[i] as TextField).addEventListener(MouseEvent.CLICK, clickedAnswer);
				addChild(choices[i]);
				
			}
			
		}
		
		public function selectRandom(array : Array) : Object
		{
			return array[Math.round(Math.random() * (array.length - 1))];
		}
		
		public function clickedAnswer (mE : MouseEvent) : void
		{
			if ((mE.target as TextField).text == textFormat.font) 
			{
				bg.backgroundColor = 0x80FF80;
				wins ++;
				winsDisplay.text = wins.toString();
				addChild(next);
			}
			else {
				bg.backgroundColor = 0xFF8080;
				losses ++;
				lossDisplay.text = losses.toString();
			}
		}
		
		public function showNext(mE : MouseEvent) : void
		{
			bg.backgroundColor = 0xFFFF80;
			removeChild(next);
			newSample();
		}
		
	}

}